\documentclass{article}
\usepackage[utf8]{inputenc}

\usepackage{preamble}
\usepackage{subcaption}
\usepackage{float}
\usepackage{tikz}
\usetikzlibrary{decorations.pathreplacing,positioning,calc,intersections,3d,shapes.geometric}

\usepackage{authblk} % to add multiple authors?

\floatstyle{boxed}
\newfloat{algorithm}{t}{}
\floatname{algorithm}{Program}

\let\vec\mathbf

\title{Intersection of tetrahedra}
\author[1]{Conor McCoid}
%\email{conor.mccoid@unige.ch}
\author[2]{Martin J. Gander }
%\email{martin.gander@unige.ch}
\affil[1,2]{University of Geneva}

\begin{document}

\maketitle

\begin{abstract}
When projecting between nonmatching three dimensional lattices, one needs to calculate the intersections of tetrahedra.
An algorithm is presented here as the three dimensional extension of the authors' two dimensional triangle-triangle intersection algorithm found in (nb: self cite).
Necessary modifications are made to adjust for the dimensionality.
Consistency errors are enumerated and their effects found to be limited.
Thus, the algorithm is shown to be robust to numerical error arising from floating point arithmetic.
An example problem is used to demonstrate its effectiveness.
\end{abstract}

\section{Introduction}
\label{sec:intro}

When considering complex problems in three dimensional space it is sometimes necessary to consider a secondary lattice overlapping a primary.
While one hopes these lattices align in some way, this is not guaranteed.
It is then a problem to project from one lattice onto the other.
In such instances it is necessary to intersect the lattices, observing how much two given volumes share a space.
The intersection between two tetrahedra must be calculated, ideally quickly and robustly.

% discuss current algorithms in use, or suggested (lit review)

This article continues the work done in (nb: self cite).
The authors' previous article presents an algorithm for triangle-triangle intersections in 2D.
It goes on to prove that the algorithm is robust in floating point arithmetic.

This algorithm is summarized here.
It calculates the intersection between two triangles $U$ and $V$.
Note that the $\sign(p)$ function used here is defined as
\begin{equation*}
\sign(p) = \begin{cases} 0 & p < 0, \\ 1 & p \geq 0. \end{cases}
\end{equation*}

\begin{description}
    \item[Step 1: Change of coordinates.] Find an affine transformation such that the three vertices of $V$ are mapped to (0,0), (1,0) and (0,1), the vertices of a reference triangle $Y$.
    Use this transformation to map $U$ to the triangle $X$.
    \item[Step 2: Select reference line.] Choose a reference line of the reference triangle $Y$.
    Apply another affine transformation (usually trivial) to the vertices of $X$ such that the edge of $Y$ lies on $\Set{p,q}{q \in [0,1]}$ and $Y \subset \Set{p,q}{p \geq 0}$.
    The $i$--th vertex of $X$ has coordinates $(p_i,q_i)$.
    \begin{description}
        \item[2a: Intersections.] Test if $\sign(p_i) \neq \sign(p_j)$.
        If so, calculate the intersection with the reference line and test if it lies on the edge of the reference triangle.
        Repeat this step for all three pairs of vertices of $X$.
        At most two intersections are found for each reference line, $q_0^1$ and $q_0^2$.
        One may remove duplicates at this stage but it is not necessary.
        \item[2b: Vertices of $Y$ in $X$.] Test if $0,1 \in [q_0^1,q_0^2]$.
        If either are in the interval, the corresponding vertex of $Y$ is determined to lie within $X$.
    \end{description}
    Repeat step 2 for each of the three reference lines.
    \item[Step 3: Vertices of $X$ in $Y$.] Multiply the three values of $\sign(p_i)$ together for each of the three vertices of $X$.
    The result will either be 0 or 1.
    If it is 1, the vertex lies inside $Y$.
    % make additional tests for vertices of Y in X
    \item[Step 4: Reverse change of coordinates.] The positions of the vertices of $U$ and $V$ are already known and so no additional calculations are required.
    For the intersections one must apply the inverse affine transformations.
\end{description}

Since part of a tetrahedron-tetrahedron intersection involves intersections in 2D planes, this algorithm can be used as a subroutine.
In truth, only two major additions need to be made to make this algorithm work in 3D.
Firstly, one needs to calculate the intersections between the edges of a clipping tetrahedron $U$ and the planes extending from the faces of a subject tetrahedron $V$.
Secondly, one needs to carefully consider the shared edges of the faces of $V$.

\section{Change of coordinates}
\label{sec:coords}

\def\one{\boldsymbol{1}^\top}

To simplify calculations, transform the tetrahedron $V$ into the reference tetrahedron $Y$ with vertices at the positions $(0,0,0)$, $(1,0,0)$, $(0,1,0)$ and $(0,0,1)$.
The tetrahedron $U$ is likewise transformed under the same affine transformation into the tetrahedron $X$.
To do so, one must determine the nature of the affine transformation.

Represent the positions of the vertices of $V$ by the matrix $$\vec{v}_0 \one + \begin{bmatrix} \vec{0} & \vec{v}_1 & \vec{v}_2 & \vec{v}_3 \end{bmatrix},$$
where $\vec{v}_0$ is the position of the vertex to be mapped to the origin,
$\vec{v}_1$, $\vec{v}_2$ and $\vec{v}_3$ are the vectors leading between $\vec{v}_0$ and the remaining vertices,
$\vec{0}$ is a column vector with three zeros
and $\one = \begin{bmatrix} 1 & 1 & 1 & 1 \end{bmatrix}$.
Ideally, $\vec{v}_1$, $\vec{v}_2$ and $\vec{v}_3$ are orthogonal.
The best choice of $\vec{v}_0$ is one in which this is true, or nearly so.

The process of transforming from the vertices of $V$ to the vertices of $Y$ can be written as an affine transformation:
\begin{equation*}
    A \left ( \vec{v}_0 \one + \begin{bmatrix} \vec{0} & \vec{v}_1 & \vec{v}_2 & \vec{v}_3 \end{bmatrix} \right ) + \vec{b} \one = \begin{bmatrix} 0 & 1 & 0 & 0 \\ 0 & 0 & 1 & 0 \\ 0 & 0 & 0 & 1 \end{bmatrix} .
\end{equation*}
The vector $\vec{b}$ is then $-A\vec{v}_0$ and the matrix $A$ is the inverse of the matrix $\begin{bmatrix} \vec{v}_1 & \vec{v}_2 & \vec{v}_3\end{bmatrix}$.

This affine transformation must be applied to the 'subject' tetrahedron $U$ to acquire its transformation $X$.
As with $V$, the position of the vertices of $U$ may be represented by the matrix $\vec{u}_0 \one + \begin{bmatrix} \vec{0} & \vec{u}_1 & \vec{u}_2 & \vec{u}_3 \end{bmatrix}$.
Let the $i$--th vertex of $X$ have position $(x_i,y_i,z_i)$.
These values may then be found by solving the system
\begin{equation*}
    \begin{bmatrix} \vec{v}_1 & \vec{v}_2 & \vec{v}_3 \end{bmatrix} \begin{bmatrix} x_1 & x_2 & x_3 & x_4 \\ y_1 & y_2 & y_3 & y_4 \\ z_1 & z_2 & z_3 & z_4 \end{bmatrix} = \vec{u}_0 \one + \begin{bmatrix} \vec{0} & \vec{u}_1 & \vec{u}_2 & \vec{u}_3 \end{bmatrix} - \vec{v}_0 \one.
\end{equation*}

\section{Corners of the intersection}

The intersection between the tetrahedra $X$ and $Y$ is a polyhedron $Z$.
There are four types of corners to this polyhedron:
vertices of $X$ that lie inside $Y$;
intersections between the edges of $X$ and the faces of $Y$;
intersections between the faces of $X$ and the edges of $Y$ and;
vertices of $Y$ that lie inside $X$.
These corners form a hierarchy, with each type informing the calculations of later types.
The levels of this hierarchy will be considered one at a time.

\subsection[Vertices of X that lie inside Y]{Vertices of $X$ that lie inside $Y$}

\newcommand{\pxi}[1]{p_\gamma(\vec{x}_{#1})}
\newcommand{\spi}[1]{\sign(p_\gamma(\vec{x}_{#1}))}
\newcommand{\qxi}[1]{q_\gamma(\vec{x}_{#1})}
\newcommand{\rxi}[1]{r_\gamma(\vec{x}_{#1})}

The reference tetrahedron $Y$ is bounded by four infinite planes:
$P_x = \set{x=0}$, $P_y=\set{y=0}$, $P_z=\set{z=0}$ and $P_{xyz}=\set{x+y+z=1}$.
Each plane $P_\gamma$ defines a parameter $p_\gamma(\vec{x})$ that is positive or zero when the point $\vec{x}=(x,y,z) \in Y$ and negative otherwise.
For three of these planes this parameter is one of the coordinates, $p_\gamma=\gamma$ for $\gamma \in \set{x,y,z}$.
For the fourth plane, $p_{xyz}(\vec{x})=1-x-y-z$.
The $i$--th vertex of $X$, $\vec{x}_i=(x_i,y_i,z_i)$, lies in $Y$ if and only if $\spi{i}=1$ for all $\gamma$.

The signs of $p_\gamma(\vec{x}_i)$ indicate the number of intersections between the edges of $X$ and the plane $P_\gamma$ to calculate.
For example, the edge between the $i$--th and $j$--th vertices of $X$ intersects $P_\gamma$ only if $\spi{i} \neq \spi{j}$, assuming neither value of $p_\gamma$ is equal to zero.
The case where $\pxi{i}=0$ is considered in (nb: self-cite) and will be briefly summarized here.
Moving $\vec{x}_i$ an imperceptible distance into $Y$ does not change the shape of the polyhedron of intersection.
Thus, the degenerate case where $\pxi{i}=0$ can be treated as the non-degenerate case where $\pxi{i}=\epsilon/2$.
It is therefore practical to use the binary-valued sign function previously defined.

\newcommand{\pairs}{\text{pairs}}

\begin{prop} \label{prop:tetra intersections}
Only 0, 3 or 4 intersections may occur between the edges of $X$ and the plane $P_\gamma$.
\end{prop}

\begin{proof}
For an intersection to exist, $\spi{i}$ and $\spi{j}$ must disagree.
There are four $\pxi{i}$ ($i=1,...,4$), and $\spi{i}$ may take one of two values.
There are only three ways to partition four objects ($\pxi{i}$) into two groups (either 0 or 1), which may be proven by the partition function.
These partitionings are listed in Table \ref{tab:partition}, where $m(a)$ and $m(b)$ are the multiplicities of elements labelled $a$ and $b$, respectively.
\begin{table}
    \centering
    \begin{tabular}{c|c|c}
        $m(a)$ & $m(b)$ & pairs \\ \hline
        4 & 0 & 0 \\
        3 & 1 & 3 \\
        2 & 2 & 4 \\
    \end{tabular}
    \caption{Ways to partition four elements into two parts.}
    \label{tab:partition}
\end{table}
A pair is formed by taking one element of each group.
The number of pairs is then the product of the two multiplicities.
\end{proof}

This proposition tells us that the part of $X$ that intersects the plane of $Y$ is a triangle, a quadrilateral, or does not exist.
This allows us to consider the intersection of these shapes with the face of $Y$ that lies in the plane.

\subsection{Intersections between edges of $X$ and faces of $Y$}
\label{sec:edgeX}

Suppose $\spi{i} \neq \spi{j}$ for some $\gamma$.
Then there is an intersection between the edge of $X$ lying between the $i$--th and $j$--th vertices and the plane $P_\gamma$.
This intersection lies in the plane $P_\gamma$ and so its value of $p_\gamma$ is zero.
There remain two coordinates needed to ascertain its position in $\bbr^3$.

We parametrize the plane $P_\gamma$ with the coordinates $q_\gamma$ and $r_\gamma$.
These are chosen such that the face of $Y$ lies between the lines $q_\gamma=0$, $r_\gamma=0$ and $q_\gamma + r_\gamma=1$.
\begin{table}
\centering
\begin{tabular}{c|c|c|c|c}
    Parameters & $x=0$ & $y=0$ & $z=0$ & $x+y+z=1$ \\ \hline
    $p_\gamma$ & $x$   & $y$   & $z$   & $1-x-y-z$   \\
    $q_\gamma$ & $y$   & $z$   & $x$   & $x$         \\
    $r_\gamma$ & $z$   & $x$   & $y$   & $y$
\end{tabular}
\caption{Parameterizations of the point $(x,y,z)$ for the given plane.}
\label{tab:parameters}
\end{table}
They are listed in Table \ref{tab:parameters}.

\begin{table}
	\centering
	\begin{tabular}{c||c|c|c}
	Plane $P$ & Numerator of $q_\gamma^{ij}$ & Numerator of $r_\gamma^{ij}$ & Numerator of $1-q_\gamma^{ij}-r_\gamma^{ij}$ \\ \hline \hline
	$x=0$ & $\begin{vmatrix} x_i & y_i \\ x_j & y_j \end{vmatrix}$ & $\begin{vmatrix} x_i & z_i \\ x_j & z_j \end{vmatrix}$ & $\begin{vmatrix} x_i & 1-y_i-z_i \\ x_j & 1- y_j-z_j \end{vmatrix}$ \\ \hline
	$y=0$ & $\begin{vmatrix} y_i & z_i \\ y_j & z_j \end{vmatrix}$ & $\begin{vmatrix} y_i & x_i \\ y_j & x_j \end{vmatrix}$ & $\begin{vmatrix} y_i & 1-x_i-z_i \\ y_j & 1-x_j-z_j \end{vmatrix}$ \\ \hline
	$z=0$ & $\begin{vmatrix} z_i & x_i \\ z_j & x_j \end{vmatrix}$ & $\begin{vmatrix} z_i & y_i \\ z_j & y_j \end{vmatrix}$ & $\begin{vmatrix} z_i & 1-x_i-y_i \\ z_j & 1-x_j-y_j \end{vmatrix}$ \\ \hline
	$x+y+z=1$ & $\begin{vmatrix} 1-y_i-z_i & x_i \\ 1-y_j-z_j & x_j \end{vmatrix}$ & $\begin{vmatrix} 1-x_i-z_i & y_i \\ 1-x_j-z_j & y_j \end{vmatrix}$ & $\begin{vmatrix} 1-x_i-y_i & z_i \\ 1-x_j-y_j & z_j \end{vmatrix}$
	\end{tabular}
	\caption{Numerators of the relevant values for each plane of $Y$.}
	\label{tab:nums}
\end{table}
(nb: introduce intersection formula?)
The intersection between $P_\gamma$ and the edge between the $i$--th and $j$--th vertices of $X$, denoted the $(ij)$--th edge, has values of $q_\gamma$ and $r_\gamma$ equal to
\begin{equation}
q_\gamma^{ij} = \frac{\qxi{j} \pxi{i} - \qxi{i} \pxi{j}}{\pxi{i}-\pxi{j}}, \quad r_\gamma^{ij} = \frac{\rxi{j} \pxi{i} - \rxi{i} \pxi{j}}{\pxi{i}-\pxi{j}}.
\end{equation}
The numerators of these values are listed in Table \ref{tab:nums} in the form of determinants.
The last row, for the plane $P_{xyz}$, has been simplified.

This intersection lies on $Y$ if and only if $q_\gamma^{ij} \geq 0$, $r_\gamma^{ij} \geq 0$ and $1-q_\gamma^{ij}-r_\gamma^{ij} \geq 0$.
Otherwise, the intersection does not fall on a face of $Y$ and is not a corner of the polyhedron $Z$.
Therefore, the sign of each of these must be found.
This is trivial for the first two, while the last involves an additional calculation.
Its numerator has been included in Table \ref{tab:nums}.
Its denominator is the same as the others, $\pxi{i}-\pxi{j}$.

Each value in Table \ref{tab:nums} appears twice.
Thus, of twelve entries only six need to be calculated.
This improves efficiency and keeps calculations consistent.

If there is no intersection with one of the other planes then the signs of one of $q_\gamma^{ij}$, $r_\gamma^{ij}$ or $1-q_\gamma^{ij}-r_\gamma^{ij}$ has the same sign as $\pxi{i}$ for this plane.
For example, if $\sign(p_y(\vec{x}_i))=\sign(p_y(\vec{x}_j))=1$ then the $(ij)$--th edge does not intersect the plane $P_y$ and any intersection between this edge and another plane of $Y$ must also be on the positive side of $P_y$.
In this case, $q_x^{ij} \geq 0$, $r_z^{ij} \geq 0$ and $r_{xyz}^{ij} \geq 0$.

If an intersection is found to lie on $Y$ then we require its coordinates in the original system.
This position is equal to $\vec{v}_0 + a \vec{v}_1 + b \vec{v}_2 + c \vec{v}_3$, where the values of $a$, $b$ and $c$ depend on the face of $Y$ the intersection lies.
\begin{table}
    \centering
    \begin{tabular}{c|c|c|c}
        Face 	& $\vec{v}_1$	& $\vec{v}_2$	& $\vec{v}_3$	\\ \hline
        $x=0$ 	& 	   		& $q_x^{ij}$ 		& $r_x^{ij}$ \\
        $y=0$ 	& $r_y^{ij}$ 		& 	       		& $q_y^{ij}$ \\
        $z=0$ 	& $q_z^{ij}$ 		& $r_z^{ij}$ 		& \\
        $x+y+z=1$ & $q_{xyz}^{ij}$ 	& $r_{xyz}^{ij}$ 		& $1-q_{xyz}^{ij}-r_{xyz}^{ij}$
    \end{tabular}
    \caption{Amount of vectors $\vec{v}_1$, $\vec{v}_2$ and $\vec{v}_3$ to add to $\vec{v}_0$ to arrive at the position of intersection between the plane $P_\gamma$ and the $(ij)$--th edge of $X$.}
    \label{tab:XwithY}
\end{table}
These values are listed in Table \ref{tab:XwithY}.

By Proposition \ref{prop:tetra intersections} there are either 0, 3 or 4 intersections between $X$ and the plane $P_\gamma$.
Thus, these intersections, if they exist, form either a triangle or a quadrilateral, denoted $G$, that may or may not intersect the face of $Y$.
By comparing the signs of $q_\gamma^{ij}$, $r_\gamma^{ij}$ and $1-q_\gamma^{ij}-r_\gamma^{ij}$ for different combinations of $i$ and $j$, which have already been found, we can determine which, if any, edges of $Y$ intersect the faces of $X$.
Moreover, we can determine which faces of $X$ these edges of $Y$ intersect by taking the triple formed by the two combinations of $i$ and $j$, noting that edges of $G$ have one of these indices in common.
For example, if $\sign(q_\gamma^{ij}) \neq \sign(q_\gamma^{ik})$ then the line $q_\gamma=0$ intersects the plane formed by the $i$--th, $j$--th and $k$--th vertices of $X$.

\subsection{Intersections between faces of $X$ and edges of $Y$}

Continuing the example from above, suppose there is an intersection between the $(ijk)$--th plane of $X$ with the line $q_\gamma=0$ for some $\gamma$.
Suppose there is an edge of $G$ between its $(ij)$--th and $(ik)$--th vertices.
Then the intersection along $q_\gamma=0$ is
\begin{equation*}
q_\gamma^0 = \frac{r_\gamma^{ik} q_\gamma^{ij} - r_\gamma^{ij} q_\gamma^{ik}}{q_\gamma^{ij} - q_\gamma^{ik}}.
\end{equation*}
As mentioned in Section \ref{sec:edgeX}, this is calculated only if $\sign(q_\gamma^{ij}) \neq \sign(q_\gamma^{ik})$.

Given that the edges of $G$ are straightforward to determine, this procedure would find at most two intersections for each edge of a face of $Y$.
However, each edge is shared by two faces of $Y$.
For each intersection there are then two sets of calculations to produce it, with no guarantee that numerical error will keep them the same.
Thus, we seek a single formula for each intersection that is independent of any particular face of $Y$.

Each edge of $Y$ can be parametrized by a single value.
We denote this parameter by $t_{\gamma,\eta}$ where $\gamma$ and $\eta$ indicate the planes of $Y$ that intersect at the particular edge.
This parameter is chosen such that the edge of $Y$ lies between $t_{\gamma,\eta}=0$ and $t_{\gamma,\eta}=1$.
\begin{table}
	\centering
	\begin{tabular}{r|c|c|c||r|c|c|c}
		$\gamma$, $\eta$ & $x$ & $y$ & $z$ & $\gamma$, $\eta$ & $x$ & $y$ & $z$ \\ \hline
		$y$, $z$ & $t_{y,z}$ & & & $z$, $xyz$ & $1-t_{z,xyz}$ & $t_{z,xyz}$ \\
		$x$, $z$ & & $t_{x,z}$ & & $y$, $xyz$ & $t_{y,xyz}$ & & $1-t_{y,xyz}$ \\
		$x$, $y$ & & & $t_{x,y}$ & $x$, $xyz$ & & $1-t_{x,xyz}$ & $t_{x,xyz}$
	\end{tabular}
	\caption{Coordinates of points along edges of $Y$ parametrized by $t_{\gamma,\eta}$.}
	\label{tab:t}
\end{table}
The $(x,y,z)$--coordinates of points along these edges are listed in Table \ref{tab:t}.

This table also provides the transformation of these points into the original coordinate system in the same manner as Table \ref{tab:XwithY}.
Starting from position $\vec{v}_0$, add $\vec{v}_1$ times the $x$--coordinate, $\vec{v}_2$ times the $y$--coordinate and $\vec{v}_3$ times the $z$--coordinate.
For example, the position of a point along the edge indexed by $y,z$ is $\vec{v}_0 + t_{y,z} \vec{v}_1$.

\newcommand{\detijk}{\begin{vmatrix} x_i & y_i & z_i \\ x_j & y_j & z_j \\ x_k & y_k & z_k \end{vmatrix}}
\begin{lemma} \label{lem:t}
The value of the parameter $t_{\gamma,\eta}$ at the intersection between the $(ijk)$--th plane of $X$ and the line extending from the edge of $Y$ indexed by $\gamma,\eta$ is
\begin{align*}
t_{y,z}^{ijk} & = \frac{\detijk}{\begin{vmatrix} 1 & y_i & z_i \\ 1 & y_j & z_j \\ 1 & y_k & z_k \end{vmatrix}}, & t_{z,xyz}^{ijk} & = \frac{\begin{vmatrix} 1-x_i & y_i & z_i \\ 1-x_j & y_j & z_j \\ 1-x_k & y_k & z_k \end{vmatrix}}{\begin{vmatrix} 1 & x_i+y_i & z_i \\ 1 & x_j+y_j & z_j \\ 1 & x_k+y_k & z_k \end{vmatrix}}, \displaybreak[0] \\
t_{x,z}^{ijk} & = \frac{\detijk}{\begin{vmatrix} x_i & 1 & z_i \\ x_j & 1 & z_j \\ x_k & 1 & z_k \end{vmatrix}}, & t_{y,xyz}^{ijk} & = \frac{\begin{vmatrix} x_i & y_i & 1-z_i \\ x_j & y_j & 1-z_j \\ x_k & y_k & 1-z_k \end{vmatrix}}{\begin{vmatrix} x_i+z_i & y_i & 1 \\ x_j+z_j & y_j & 1 \\ x_k+z_k & y_k & 1 \end{vmatrix}}, \displaybreak[0] \\
t_{x,y}^{ijk} & = \frac{\detijk}{\begin{vmatrix} x_i & y_i & 1 \\ x_j & y_j & 1 \\ x_k & y_k & 1 \end{vmatrix}}, & t_{x,xyz}^{ijk} & = \frac{\begin{vmatrix} x_i & 1-y_i & z_i \\ x_j & 1-y_j & z_j \\ x_k & 1-y_k & z_k \end{vmatrix}}{\begin{vmatrix} x_i & 1 & y_i + z_i \\ x_j & 1 & y_j+z_j \\ x_k & 1 & y_k+z_k \end{vmatrix}}.
\end{align*}
The value of $1-t_{\gamma,\eta}^{ijk}$ is
\begin{align*}
1-t_{y,z}^{ijk} & = \frac{\begin{vmatrix} 1-x_i & y_i & z_i \\ 1-x_j & y_j & z_j \\ 1-x_k & y_k & z_k \end{vmatrix}}{\begin{vmatrix} 1 & y_i & z_i \\ 1 & y_j & z_j \\ 1 & y_k & z_k \end{vmatrix}}, &
1-t_{z,xyz}^{ijk} & = -\frac{\begin{vmatrix} x_i & 1-y_i & z_i \\ x_j & 1-y_j & z_j \\ x_k & 1-y_k & z_k \end{vmatrix}}{\begin{vmatrix} 1 & x_i+y_i & z_i \\ 1 & x_j+y_j & z_j \\ 1 & x_k+y_k & z_k \end{vmatrix}}, \displaybreak[0] \\
1-t_{x,z}^{ijk} & = \frac{\begin{vmatrix} x_i & 1-y_i & z_i \\ x_j & 1-y_j & z_j \\ x_k & 1-y_k & z_k \end{vmatrix}}{\begin{vmatrix} x_i & 1 & z_i \\ x_j & 1 & z_j \\ x_k & 1 & z_k \end{vmatrix}}, &
1-t_{y,xyz}^{ijk} & = -\frac{\begin{vmatrix} 1-x_i & y_i & z_i \\ 1-x_j & y_j & z_j \\ 1-x_k & y_k & z_k \end{vmatrix}}{\begin{vmatrix} x_i+z_i & y_i & 1 \\ x_j+z_j & y_j & 1 \\ x_k+z_k & y_k & 1 \end{vmatrix}}, \displaybreak[0] \\
1-t_{x,y}^{ijk} & = \frac{\begin{vmatrix} x_i & y_i & 1-z_i \\ x_j & y_j & 1-z_j \\ x_k & y_k & 1-z_k \end{vmatrix}}{\begin{vmatrix} x_i & y_i & 1 \\ x_j & y_j & 1 \\ x_k & y_k & 1 \end{vmatrix}}, &
1-t_{x,xyz}^{ijk} & = -\frac{\begin{vmatrix} x_i & y_i & 1-z_i \\ x_j & y_j & 1-z_j \\ x_k & y_k & 1-z_k \end{vmatrix}}{\begin{vmatrix} x_i & 1 & y_i + z_i \\ x_j & 1 & y_j+z_j \\ x_k & 1 & y_k+z_k \end{vmatrix}}.
\end{align*}
\end{lemma}

\begin{proof}
Consider the $(ijk)$--th face of $X$.
This face defines a plane, $ax + by +cz = d$.
The intersection between this plane and the line $y,z$, where $y=z=0$, is $(d/a,0,0)$.
Likewise, for the lines $x,z$ and $x,y$ the intersections are $(0,d/b,0)$ and $(0,0,d/c)$, respectively.

Consider the intersection between this plane and the line $x,xyz$.
This intersection is the solution to the linear system
\begin{equation*}
\begin{bmatrix} 1 & 0 & 0 \\ 1 & 1 & 1 \\ a & b & c \end{bmatrix} \vec{x} = \begin{bmatrix} 0 \\ 1 \\ d \end{bmatrix}
\end{equation*}
which is $(0,-(c-d)/(b-c),(b-d)/(b-c))$.
The intersections between the plane and the lines $y,xyz$ and $z,xyz$ can be found in the same manner.

The values of $a$, $b$ and $c$ can be found by solving the linear system
\begin{equation*}
\begin{bmatrix} x_i & y_i & z_i \\ x_j & y_j & z_j \\ x_k & y_k & z_k \end{bmatrix} \begin{bmatrix} a \\ b \\ c \end{bmatrix} = d \begin{bmatrix} 1 \\ 1 \\ 1 \end{bmatrix} .
\end{equation*}
Cramer's rule (nb: cite?) gives the solution as
\begin{equation*}
\frac{a}{d} = \frac{ \begin{vmatrix} 1 & y_i & z_i \\ 1 & y_j & z_j \\ 1 & y_k & z_k \end{vmatrix} }{\detijk}, \quad
\frac{b}{d} = \frac{ \begin{vmatrix} x_i & 1 & z_i \\ x_j & 1 & z_j \\ x_k & 1 & z_k \end{vmatrix} }{\detijk}, \quad
\frac{c}{d} = \frac{ \begin{vmatrix} x_i & y_i & 1 \\ x_j & y_j & 1 \\ x_k & y_k & 1 \end{vmatrix} }{\detijk}.
\end{equation*}
The values of $t_{y,z}^{ijk}$, $t_{x,z}^{ijk}$ and $t_{x,y}^{ijk}$ are then the inverses of these fractions.
The values of $1-t_{y,z}^{ijk}$, $1-t_{x,z}^{ijk}$ and $1-t_{x,y}^{ijk}$ can be simplified using known properties of the determinant.

The value of $t_{x,xyz}^{ijk}$ is
\begin{align*}
t_{x,xyz}^{ijk} & = \frac{b-d}{b-c} = \frac{\frac{b}{d}-1}{\frac{b}{d}-\frac{c}{d}}
= \frac{ \begin{vmatrix} x_i & 1 & z_i \\ x_j & 1 & z_j \\ x_k & 1 & z_k \end{vmatrix} - \detijk }{\begin{vmatrix} x_i & 1 & z_i \\ x_j & 1 & z_j \\ x_k & 1 & z_k \end{vmatrix} - \begin{vmatrix} x_i & y_i & 1 \\ x_j & y_j & 1 \\ x_k & y_k & 1 \end{vmatrix}} \\
& = \frac{\begin{vmatrix} x_i & 1-y_i & z_i \\ x_j & 1-y_j & z_j \\ x_k & 1-y_k & z_k \end{vmatrix}}{\begin{vmatrix} x_i & 1 & z_i \\ x_j & 1 & z_j \\ x_k & 1 & z_k \end{vmatrix} + \begin{vmatrix} x_i & 1 & y_i \\ x_j & 1 & y_j \\ x_k & 1 & y_k \end{vmatrix} }
= \frac{\begin{vmatrix} x_i & 1-y_i & z_i \\ x_j & 1-y_j & z_j \\ x_k & 1-y_k & z_k \end{vmatrix}}{\begin{vmatrix} x_i & 1 & y_i + z_i \\ x_j & 1 & y_j+z_j \\ x_k & 1 & y_k+z_k \end{vmatrix}}.
\end{align*}
The value of $1-t_{x,xyz}^{ijk}$ has already been shown to be $-(c-d)/(b-c)$ and a similar expression as above can be found by following the same steps.
The remaining values of $t_{\gamma,\eta}^{ijk}$ and $1-t_{\gamma,\eta}^{ijk}$ are also found in this manner.
\end{proof}

If $t_{\gamma,\eta}^{ijk}$ is between 0 and 1 then the corresponding intersection lies on the corresponding edge of $Y$.
Note that the values of $1-t_{\gamma,\eta}^{ijk}$ do not need to be calculated explicitly as only their signs are important.

In the case where $\sign(r_\gamma^{ij}) = \sign(r_\gamma^{ik})$ the sign of $t_{\gamma,\eta}^{ijk}$ can be determined without additional calculations.
Since the line connecting the $(ij)$--th intersection to the $(ik)$--th intersection lies entirely on one side of the line $r_\gamma=0$ the sign of $t_{\gamma,\eta}^{ijk}$ must be equal to both $\sign(r_\gamma^{ij})$ and $\sign(r_\gamma^{ik})$.
For some edges $r_\gamma$ is replaced by $q_\gamma$ or $1-q_\gamma-r_\gamma$ and $t_{\gamma,\eta}$ by $1-t_{\gamma,\eta}$.
In this way, the sign of $t_{\gamma,\eta}^{ijk}$ needs to be independently calculated only when the $(ijk)$--th plane of $X$ intersects three lines extending from the edges of $Y$.

Each numerator appears in Lemma \ref{lem:t} three times.
Each denominator appears twice.
The numerators are connected by the vertices of $Y$:
All edges extending from a given vertex of $Y$ share the numerator of either $t_{\gamma,\eta}^{ijk}$ or $1-t_{\gamma,\eta}^{ijk}$.
The denominators are specific to each edge.
These denominators have common signs with the numerators of Table \ref{tab:nums}.

\begin{lemma}
Suppose the $(ijk)$--th face of $X$ intersects the line $\gamma,\eta$ of $Y$.
Suppose $\spi{i} \neq \spi{j} = \spi{k}$.
If the line $\gamma,\eta$ coincides with $q_\gamma=0$ then
\begin{equation*}
\sign \left ( \begin{vmatrix} 1 & \pxi{i} & \qxi{i} \\ 1 & \pxi{j} & \qxi{j} \\ 1 & \pxi{k} & \qxi{k} \end{vmatrix} \right ) = \sign \left ( \begin{vmatrix} \pxi{i} & \qxi{i} \\ \pxi{j} & \qxi{j} \end{vmatrix} \right ) .
\end{equation*}
If the line coincides with $q_\gamma+r_\gamma=1$ then
\begin{equation*}
\sign \left ( \begin{vmatrix} 1 & \qxi{i}+\rxi{i} & \pxi{i} \\ 1 & \qxi{j}+\rxi{j} & \pxi{j} \\ 1 & \qxi{k}+\rxi{k} & \pxi{k} \end{vmatrix} \right ) = \sign \left ( \begin{vmatrix} \pxi{i} & 1-\qxi{i}-\rxi{i} \\ \pxi{j} & 1-\qxi{j}-\rxi{j} \end{vmatrix} \right ) .
\end{equation*}
\end{lemma}

\begin{proof}
The intersection along $q_\gamma=0$ has already been given and involves division by $q_\gamma^{ij} - q_\gamma^{ik}$.
The value of this denominator is
\begin{align*}
q_\gamma^{ij} - q_\gamma^{ik} = & \frac{\begin{vmatrix} \pxi{i} & \qxi{i} \\ \pxi{j} & \qxi{j} \end{vmatrix}}{\pxi{i} - \pxi{j}} - \frac{\begin{vmatrix} \pxi{i} & \qxi{i} \\ \pxi{k} & \qxi{k}\end{vmatrix}}{\pxi{i} - \pxi{k}} \\
% = & \frac{(\pxi{i} - \pxi{k}) \begin{vmatrix} \pxi{i} & \qxi{i} \\ \pxi{j} & \qxi{j} \end{vmatrix} - (\pxi{i} - \pxi{j}) \begin{vmatrix} \pxi{i} & \qxi{i} \\ \pxi{k} & \qxi{k} \end{vmatrix} }{ (\pxi{i} - \pxi{j})(\pxi{i} - \pxi{k}) } \\
= & \frac{\pxi{i} \begin{vmatrix} 0 & \pxi{i} & \qxi{i} \\ 1 & \pxi{j} & \qxi{j} \\ 1 & \pxi{k} & \qxi{k} \end{vmatrix} - \begin{vmatrix} 0 & \pxi{i} & \qxi{i} \\ \pxi{j} & \pxi{j} & \qxi{j} \\ \pxi{k} & \pxi{k} & \qxi{k} \end{vmatrix} }{ (\pxi{i} - \pxi{j})(\pxi{i} - \pxi{k}) } \\
= & \frac{\pxi{i} \begin{vmatrix} 0 & \pxi{i} & \qxi{i} \\ 1 & \pxi{j} & \qxi{j} \\ 1 & \pxi{k} & \qxi{k} \end{vmatrix} - \begin{vmatrix} -\pxi{i} & \pxi{i} & \qxi{i} \\ 0 & \pxi{j} & \qxi{j} \\ 0 & \pxi{k} & \qxi{k} \end{vmatrix} }{ (\pxi{i} - \pxi{j})(\pxi{i} - \pxi{k}) } \\
= & \frac{\pxi{i} \begin{vmatrix} 1 & \pxi{i} & \qxi{i} \\ 1 & \pxi{j} & \qxi{j} \\ 1 & \pxi{k} & \qxi{k} \end{vmatrix}}{\left ( \pxi{i} - \pxi{j} \right ) \left ( \pxi{i} - \pxi{k} \right )} .
\end{align*}
Since this intersection exists only if $\sign(q_\gamma^{ij}) \neq \sign(q_\gamma^{ik})$ this denominator has the same sign as $q_\gamma^{ij}$, which has the sign of
\begin{equation*}
\begin{vmatrix} \pxi{i} & \qxi{i} \\ \pxi{j} & \qxi{j} \end{vmatrix} \pxi{i} .
\end{equation*}
By comparing these signs it is clear that
\begin{equation*}
\sign \left ( \begin{vmatrix} 1 & \pxi{i} & \qxi{i} \\ 1 & \pxi{j} & \qxi{j} \\ 1 & \pxi{k} & \qxi{k} \end{vmatrix} \right ) = \sign \left ( \begin{vmatrix} \pxi{i} & \qxi{i} \\ \pxi{j} & \qxi{j} \end{vmatrix} \right ) .
\end{equation*}

The intersection along $q_\gamma+r_\gamma=1$ involves division by $(1-q_\gamma^{ij}-r_\gamma^{ij}) - (1-q_\gamma^{ik}-r_\gamma^{ik})$.
Again, this only exists if these two terms differ in sign and this denominator has the same sign as $1-q_\gamma^{ij}-r_\gamma^{ij}$, which is
\begin{equation*}
\sign \left ( \begin{vmatrix} \pxi{i} & 1-\qxi{i}-\rxi{i} \\ \pxi{j} & 1-\qxi{j}-\rxi{j} \end{vmatrix} \pxi{i} \right ) .
\end{equation*}
The value of the denominator can be found by replacing $q_\gamma$ by $1-q_\gamma-r_\gamma$ in the formulas above.
To arrive at the form in the statement of the lemma one must simplify the determinant
\begin{align*}
\begin{vmatrix} 1 & \pxi{i} & 1-\qxi{i}-\rxi{i} \\ 1 & \pxi{j} & 1-\qxi{j}-\rxi{j} \\ 1 & \pxi{k} & 1-\qxi{k}-\rxi{k} \end{vmatrix}
= & \begin{vmatrix} 1 & \pxi{i} & 1 \\ 1 & \pxi{j} & 1 \\ 1 & \pxi{k} & 1 \end{vmatrix} -
\begin{vmatrix} 1 & \pxi{i} & \qxi{i}+\rxi{i} \\ 1 & \pxi{j} & \qxi{j}+\rxi{j} \\ 1 & \pxi{k} & \qxi{k}+\rxi{k} \end{vmatrix} \\
= & \begin{vmatrix} 1 & \qxi{i}+\rxi{i} & \pxi{i} \\ 1 & \qxi{j}+\rxi{j} & \pxi{j} \\ 1 & \qxi{k}+\rxi{k} & \pxi{k} \end{vmatrix} .
\end{align*}
Comparison with the known sign of this denominator results in the statement of the lemma.
\end{proof}

This connects the denominators of Lemma \ref{lem:t} with the numerators of Table \ref{tab:nums}.
Depending on the indices and the particular $q_\gamma$ and $p_\gamma$ some row and column swapping may be necessary.
Each swap incurs a sign change.
Note also that $q_\gamma$ will be replaced by $r_\gamma$ in some instances.
Since each edge of $Y$ is shared by two of its faces there is no need to use $\gamma=xyz$ to connect these signs.

\subsection{Vertices of $Y$ that lie inside $X$}

Each edge of $Y$ has two vertices attached to it.
These are located at $t_{\gamma,\eta}=0$ and $t_{\gamma,\eta}=1$.
Either two or zero faces of $X$ intersect this edge, resulting in $t_{\gamma,\eta}^{ijk}$ and $t_{\gamma,\eta}^{ijl}$.
If the signs of these values are different then the vertex at $t_{\gamma,\eta}=0$ must lie inside $X$.
The same is true of $1-t_{\gamma,\eta}^{ijk}$, $1-t_{\gamma,\eta}^{ijl}$ and the vertex at $t_{\gamma,\eta}=1$.

Each vertex of $Y$ has three edges extending from it.
This test can therefore occur up to three times.
If the algorithm is consistent it needs only to occur once.
The remaining edges would then agree on the results.
Using the edges of the plane $P_{xyz}$ for these tests removes the need to test the signs of $1-t_{\gamma,\eta}^{ijk}$ as each of these edges has a separate vertex of $Y$ at $t_{\gamma, xyz}=0$.
The final vertex of $Y$, at the origin, can use any of the remaining edges, as they all have this vertex at $t_{\gamma,\eta}=0$.

\section{Algorithm}

There are four types of points to find to construct the polyhedron of intersection.
They are presented in Table \ref{tab:corners}.
\begin{table}
    \centering
    \begin{tabular}{c|c|c}
        Type of corner & Shorthand & Test \\ \hline
        Vertex of $X$ inside $Y$ & $X$--in--$Y$ & $\Pi_p \sign(p_i) = 1$ \\
        Intersection, edge of $X$ and face of $Y$ & $X$--with--$Y$ & $\Pi_s \sign(s_i) = 1$ \\
        Intersection, edge of $Y$ and face of $X$ & $Y$--with--$X$ & $T_1$, $T_2 \in [0,1]$ \\
        Vertex of $Y$ inside $X$ & $Y$--in--$X$ & 0, $1 \in [T_1,T_2]$
    \end{tabular}
    \caption{Hierarchy of corners of the polyhedron of intersection.}
    \label{tab:corners}
\end{table}

\begin{description}
\item[Step 1: Change of coordinates.]
As described in Section \ref{sec:coords}, $V$ is transformed into $Y$ and $U$ into $X$.

\item[Step 2: Select plane $P_\gamma$ of $Y$.]
Calculate $\pxi{i}$, $\qxi{i}$ and $\rxi{i}$ for all vertices of $X$, $i=1,\dots,4$.
	\begin{description}
	\item[Step 2a: Intersections between $P_\gamma$ and edges of $X$.]
	Test if $\sign(\pxi{i}) \neq \sign(\pxi{j})$.
	If so, calculate the intersection between $p_\gamma=0$ and the edge connecting the $i$--th and $j$--th vertices of $X$, found using the coordinates $q^{ij}_\gamma$ and $r_\gamma^{ij}$.
	If $q_\gamma^{ij}$, $r_\gamma^{ij}$ and $1-q_\gamma^{ij}-r_\gamma^{ij}$ are all non-negative then the intersection is a corner of the polyhedron of intersection.
	Repeat for all pairs of $i$ and $j$.
	
	\item[Step 2b: Intersection between $G$ and edges of $Y$.]
	Select an edge of $Y$ that lies in $P_\gamma$.
	Without loss of generality, suppose this aligns with $q_\gamma=p_\eta=0$.
	Test if $\sign(q_\gamma^{ij}) \neq \sign(q_\gamma^{ik})$
	If so, calculate the intersection $t_{\gamma,\eta}^{ijk}$ between $G$ and this edge of $Y$.
	If $t_{\gamma,\eta}^{ijk} \in [0,1]$ then this intersection is a corner of the polyhedron of intersection.
	Repeat for all pairs of $ij$ and $ik$.
	
		\begin{description}
		\item[Step 2bi: Intersections between edges of $Y$ and faces of $X$.]
		Test if $\sign(t_{\gamma,\eta}^{ijk}) \neq \sign(t_{\gamma,\eta}^{ijl})$.
		If so, the vertex of $Y$ at $t_{\gamma,\eta}=0$ lies in $X$.
		Likewise, if $\sign(1-t_{\gamma,\eta}^{ijk}) \neq \sign(1-t_{\gamma,\eta}^{ijl})$ then the vertex of $Y$ at $t_{\gamma,\eta}=1$ lies in $X$.
		\end{description}
	Repeat step 2b for each edge of $Y$ that lies in $P_\gamma$.
	\end{description}

Repeat step 2 for each face of $Y$.
It is not necessary to repeat step 2b for edges considered in previous instances of step 2, nor step 2bi for previously considered vertices.

\item[Step 3: Vertices of $X$ in $Y$.]
Compare all values of $\pxi{i}$ for the $i$--th vertex of $X$.
If $\sign(\pxi{i}) = 1$ for all $\gamma$ then the $i$--th vertex lies inside $Y$.

\item[Step 4: Undo change of coordinates.]
Transform the intersections between edges of $X$ and faces of $Y$ (2a) and those between edges of $Y$ and faces of $X$ (2b) into the original coordinates.
The transformation from $(p,q,r)$--coordinates has been shown in Table \ref{tab:XwithY}.
The transformation from $t$--coordinate is presented in Table \ref{tab:YwithX}.
Take the numbers listed in the tables, multiply by the respective vectors $\vec{v}_i$, sum the results and add $\vec{v}_0$ for the positions in original coordinates.
\end{description}

\begin{table}
	\centering
	\begin{tabular}{c|c|c|c}
	Edge 		& $\vec{v}_1$	& $\vec{v}_2$	& $\vec{v}_3$	\\ \hline
	$y=0,z=0$ 	& $t$ 	& 		& \\
	$x=0,z=0$	& 		& $t$	& \\
	$x=0,y=0$	&		& 		& $t$ \\
	$z=0,x+y+z=1$ & $1-t$ & $t$ & \\
	$y=0,x+y+z=1$ & $t$ & 	& $1-t$ \\
	$x=0,x+y+z=1$ & 	& $1-t$ & $t$
	\end{tabular}
	\caption{Position of the intersection between an edge of $Y$ and a face of $X$ in original coordinates as functions of its $t$--coordinate.}
	\label{tab:YwithX}
\end{table}

Note that step 2b may be completed after step 2a has been completed for all planes $P_\gamma$.
Likewise, step 2bi may be completed after all instances of step 2b.
This means the algorithm can be parallelized by having steps 2a, 2b and 2bi run by separate threads.
One could also have each plane $P_\gamma$ run by separate threads, though information about which edges and vertices have already been considered would need to be passed between these threads.

\section{Consistency errors}

If the algorithm is to be robust, an error on the order of machine epsilon can only cause a change in the volume of the polyhedron of intersection on the same order of magnitude.
The polyhedron is defined by its corners.
The types of corners are listed in Table \ref{tab:corners}.
There are two types of corners arising from intersections, which may have error in their position, and two types of corners arising from vertices of the tetrahedra, which may have error in their inclusion in the polyhedron.

%Wish list:
%\begin{itemize}
%\item $Y$--in--$X$ point always surrounded by 6 $Y$--with--$X$ points
%\item At most 4 tetrahedron vertices in $Z$
%\item Other conditions that uniquely specify tetrahedron intersections
%\end{itemize}

\subsection{$X$--in--$Y$ errors}

The vertices of the tetrahedron $Y$ are fixed.
The vertices of the tetrahedron $X$ are determined by an affine transformation.
This transformation may introduce some error in their position but as only the original positions of the vertices are used to construct the polyhedron this only affects the determination of its inclusion as an $X$--in--$Y$ corner and the position of any intersections calculated based on these vertices.

Should a vertex of $X$ cross a plane of $Y$ it is crucial that the number of $X$--with--$Y$ points in the plane changes accordingly.
If this were not the case, the resulting polyhedron of intersection may not represent a realistic intersection.
For example, if the exact intersection has four corners, three $X$--with--$Y$ points and an $X$--in--$Y$ vertex, the movement of the vertex over the plane will result in a 2D intersection of 3D objects.

\begin{lemma} \label{lem:XinY}
Let $\vec{x}_i$ be the position of the $i$--th vertex and $\tilde{\vec{x}}_i$ be its position as calculated by the algorithm.
Suppose the $i$--th vertex of $X$ lies outside $Y$ but the algorithm determines it to lie inside $Y$.
The line segment between $\vec{x}_i$ and $\tilde{\vec{x}}_i$ necessarily intersects at least one plane $P_\gamma$.
The line segment between $\tilde{\vec{x}}_i$ and $\vec{x}_j$ intersects $P_\gamma$ if and only if the $(ij)$--th edge of $X$ does not.
\end{lemma}

\begin{proof}
By assumption, $\spi{i} = 0$ and $\sign \left ( \tilde{\vec{x}}_i \right ) = 1$.
Then either $$\spi{j} \neq \spi{i}$$ or $$\spi{j} \neq \sign \left ( p_\gamma \left(\tilde{\vec{x}}_i \right ) \right ) .$$
The former indicates the $(ij)$--th edge of $X$ intersects $P_\gamma$ and the line segment between $\tilde{\vec{x}}_i$ and $\vec{x}_j$ does not.
The latter indicates the reverse.
\end{proof}

The number of intersections with the plane after the error depends on the number of vertices of $X$ on each side of the plane.
We consider the five possible arrangements of the vertices with respect to the plane and indicate the change in the number of intersections found when an error causes transition from one to another, see Figure \ref{fig:XinY}.
These transitions correspond to moving between the rows of Table \ref{tab:partition}.

\newcommand{\tetra}[2]{
    \filldraw[red] \foreach \x in {#1} {(\x) circle (1.5pt)};
    \filldraw[blue,fill opacity=0.2] (S1) -- (S2) -- (S3) -- (S4) -- cycle;
    \filldraw[red] \foreach \x in {#2} {(\x) circle (1.5pt)};
    }
\newcommand{\blueplane}[4]{
    \filldraw[blue,fill opacity=0.4] #1 -- #2 -- #3 -- #4 -- cycle;
    }
\newcommand{\redplanes}[4]{
    \filldraw[red,fill opacity=0.2] #1 -- #2 -- #3 -- cycle;
    \filldraw[red,fill opacity=0.2] #1 -- #2 -- #4 -- cycle;
    \filldraw[red,fill opacity=0.2] #1 -- #3 -- #4 -- cycle;
    }

\begin{figure}
    \centering
    \begin{tikzpicture}[scale=0.45]
        % coord. set-up
        \coordinate (A1) at (-1,-1);
        \coordinate (B1) at (0,-0.75);
        \coordinate (C1) at (-0.5,1);
        \coordinate (D1) at (-1.5,0);

        \coordinate (D2) at (2,-1);
        \coordinate (B2) at (3,-0.75);
        \coordinate (C2) at (2.5,1);
        \coordinate (A2) at (3.5,0);
        
        \coordinate (S1) at (0,-2);
        \coordinate (S2) at (0,2);
        \coordinate (S3) at (2,1);
        \coordinate (S4) at (2,-1);
        
        \coordinate (int1) at ($.5*(A1)+.5*(D2)$);
        \coordinate (int2) at ($.5*(B1)+.5*(D2)$);
        \coordinate (int3) at ($.5*(C1)+.5*(D2)$);
        \coordinate (int4) at ($.5*(A1)+.5*(C2)$);
        \coordinate (int5) at ($.5*(B1)+.5*(C2)$);
        \coordinate (int6) at ($.5*(A1)+.5*(B2)$);
        
        \matrix[column sep=0.5cm, row sep=0.5cm]
        {
        \tetra{A1,B1,C1,D1}{} \redplanes{(A1)}{(D1)}{(C1)}{(B1)}&
        \tetra{A1,B1,C1}{D2} \redplanes{(A1)}{(B1)}{(C1)}{(D2)} \blueplane{(int1)}{(int2)}{(int3)}{(int3)}&
        \tetra{A1,B1}{C2,D2} \redplanes{(A1)}{(B1)}{(C2)}{(D2)} \blueplane{(int1)}{(int2)}{(int5)}{(int4)}&
        \tetra{A1}{B2,C2,D2} \redplanes{(A1)}{(B2)}{(C2)}{(D2)} \blueplane{(int1)}{(int4)}{(int6)}{(int6)}&
        \tetra{}{A2,B2,C2,D2} \redplanes{(A2)}{(B2)}{(C2)}{(D2)}\\
        };
    \end{tikzpicture}
    \caption{The five possible configurations of $X$ with respect to a plane of $Y$.
    An $X$--in--$Y$ error in a single vertex of $X$ may cause a shift from one of these to either neighbour.}
    \label{fig:XinY}
\end{figure}

Errors in $X$--in--$Y$ points then cause errors in the number of $X$--with--$Y$ points.
However, these errors provide consistency between these types of points, so that the ultimate configuration remains an intersection between tetrahedra.

\subsection{$X$--with--$Y$ errors}

The corners denoted as $X$--with--$Y$ are intersections between edges of $X$ and faces of $Y$.
An $X$--with--$Y$ corner on the polyhedron $Z$ is an intersection between an edge of $X$ and a plane $P_\gamma$ that lies between the lines $q_\gamma=0$, $r_\gamma=0$ and $q_\gamma + r_\gamma=1$.
A consistency error involving one of these corners then places one of these intersections on the wrong side of one of these lines.
To maintain consistency this must cause commensurate errors on other planes.

An $X$--with--$Y$ corner is determined by testing if the values of $q_\gamma^{ij}$, $r_\gamma^{ij}$ and $1-q_\gamma^{ij}-r_\gamma^{ij}$ are positive.
The numerators of these values are found in Table \ref{tab:nums}.
Change in the sign of one of these values is a change in the sign of the respective numerator.
As this numerator is shared with another plane for the same edge of $X$ this causes a second error.
Should an error occur with an $X$--with--$Y$ corner it is important that the number of $Y$--with--$X$ corners remains consistent.

\begin{lemma} \label{lem:XwithY}
Suppose there is an error in the sign of $q_\gamma^{ij}$ independently of any errors in $\spi{i}$ and $\spi{j}$.
Then a value of $t_{\gamma,\eta}^{ijk}$ is calculated if and only if the $(ijk)$--th plane of $X$ does not intersect the $\gamma, \eta$ edge of $Y$.
\end{lemma}

\begin{proof}
If the sign of $q_\gamma^{ij}$ is in error then so is that of $r_\eta^{ij}$.
If no value of $r_\eta^{ij}$ is calculated then $p_\eta(\vec{x}_i)$ and $p_\eta(\vec{x}_j)$ have the same sign.
The $(ij)$--th edge of $X$ then does not intersect the plane $P_\eta$ and the sign of $q_\gamma^{ij}$ cannot be in error.

By Lemma \ref{lem:XinY} there are two or three other intersections with the plane $P_\gamma$.
The same is true for the plane $P_\eta$.
One of these intersections has indices $k$ and either $i$ or $j$.
Both $q_\gamma^{ik}$ and $q_\gamma^{jk}$ cannot be calculated as $\spi{k}$ must equal either $\spi{i}$ or $\spi{j}$.

Without loss of generality we suppose there is a value of $q_\gamma^{ik}$ and a value of $r_\eta^{jk}$.
Before the error, both pairs of $(q_\gamma^{ij}, q_\gamma^{ik})$ and $(r_\eta^{ij}, r_\eta^{jk})$ either agreed or disagreed on their signs.
After the error, the signs of both $q_\gamma^{ij}$ and $r_\eta^{ij}$ have flipped.
Both pairs now have the opposite relationship between their signs.
That is, if the pairs agreed on their signs before the error they now disagree after the error, and vice versa.
Since agreement indicates no intersection between the $\gamma, \eta$ edge of $Y$ and the $(ijk)$--th plane of $X$ and disagreement the reverse this concludes the proof.
\end{proof}

If $\gamma=xyz$ then $r_\eta^{ij}$ must be replaced by $1-q_x^{ij}-r_x^{ij}$ in the statement of Lemma \ref{lem:XwithY}.
The lemma is also true when replacing $q_\gamma^{ij}$ with $r_\gamma^{ij}$ or $1-q_\gamma^{ij}-r_\gamma^{ij}$, making commenserate changes to $r_\eta^{ij}$ where applicable.
The end result ensures that an appropriate number of $Y$--with--$X$ points are calculated based on the distribution of $X$--with--$Y$ points, themselves ensured by the $X$ vertices and their values of $\spi{i}$.

\newcommand{\tikzint}[4]{{(#1*#4-#3*#2)/(#4-#2)}}
\newcommand{\Tetra}[9]{
	\coordinate (X1) at (#1,#2,#3); \coordinate (X2) at (#4,#5,#6); \coordinate (X3) at (-2,-2,-2); \coordinate (X4) at (#7,#8,#9);
		\coordinate (z1) at (\tikzint{#4}{#6}{#1}{#3},\tikzint{#5}{#6}{#2}{#3},0);
		\coordinate (z2) at (\tikzint{#4}{#6}{-2}{-2},\tikzint{#5}{#6}{-2}{-2},0);
		\coordinate (z3) at (\tikzint{#4}{#6}{#7}{#9},\tikzint{#5}{#6}{#8}{#9},0);
		\coordinate (z4) at (\tikzint{#7}{#9}{-2}{-2},\tikzint{#8}{#9}{-2}{-2},0);
		\coordinate (z5) at (\tikzint{#1}{#3}{-2}{-2},\tikzint{#2}{#3}{-2}{-2},0);
		\coordinate (z6) at (\tikzint{#7}{#9}{#1}{#3},\tikzint{#8}{#9}{#2}{#3},0);
		
		\coordinate (x1) at (0,\tikzint{#2}{#1}{#5}{#4},\tikzint{#3}{#1}{#6}{#4});
		\coordinate (x2) at (0,\tikzint{#2}{#1}{-2}{-2},\tikzint{#3}{#1}{-2}{-2});
		\coordinate (x3) at (0,\tikzint{#2}{#1}{#8}{#7},\tikzint{#3}{#1}{#9}{#7});
		\coordinate (x4) at (0,\tikzint{#8}{#7}{-2}{-2},\tikzint{#9}{#7}{-2}{-2});
		\coordinate (x5) at (0,\tikzint{-2}{-2}{#5}{#4},\tikzint{-2}{-2}{#6}{#4});
		\coordinate (x6) at (0,\tikzint{#8}{#7}{#5}{#4},\tikzint{#9}{#7}{#6}{#4});
	
	\draw[black] (0,-2,0) -- (0,2,0);
	\filldraw[blue,fill opacity=0.2] (2,-2,0) -- (2,2,0) -- (0,2,0) -- (0,2,-2) -- (0,-2,-2) -- (0,-2,0) -- cycle;
	\filldraw[red] \foreach \x in {(X1),(X2),(X3),(X4)} {\x circle (1.5pt)};
	\filldraw[red,fill opacity=0.2] (X1) -- (X2) -- (X3) -- cycle;
	\filldraw[red,fill opacity=0.2] (X1) -- (X2) -- (X4) -- cycle;
	\filldraw[red,fill opacity=0.2] (X4) -- (X2) -- (X3) -- cycle;
	\filldraw[red,fill opacity=0.2] (X1) -- (X4) -- (X3) -- cycle;
	\filldraw[blue,fill opacity=0.2] (-2,-2,0) -- (-2,2,0) -- (0,2,0) -- (0,2,2) -- (0,-2,2) -- (0,-2,0) -- cycle;
}
%\newcommand{\redplane}[2]{
%	\filldraw[red,fill opacity=0.2] #1 \foreach \x in {#2} {-- \x} -- cycle;
%}
\begin{figure}
	\centering
	\begin{tikzpicture}[rotate around y=60]
		\matrix[row sep=1em, column sep=1em,every cell/.style={scale=0.75}]{
			\Tetra{0.5}{0}{-1}{-1}{0}{0.5}{-2.05}{2}{-2.05}
			\draw[blue] (x1) -- (x2) -- (x3) -- cycle; \draw[blue] (z1) -- (z2) -- (z3) -- cycle;
			\filldraw[blue] (x1) circle (1.5pt); \filldraw[blue] (z1) circle (1.5pt); &
			\draw[<->,rotate around y=-60, very thick] (0,0,0) -- (1,0,0); &
			\Tetra{1}{0}{-0.5}{-0.5}{0}{1}{-2.05}{2}{-2.05}
			\draw[blue] (x1) -- (x2) -- (x3) -- cycle; \draw[blue] (z1) -- (z2) -- (z3) -- cycle;
			\filldraw[blue] (x1) circle (1.5pt); \filldraw[blue] (z1) circle (1.5pt);
			\filldraw[black] (intersection of z1--z2 and x1--x2) circle (1.5pt);
			\filldraw[black] (intersection of z1--z3 and x1--x3) circle (1.5pt); \\
			\Tetra{-1}{0}{0.5}{0.5}{0}{-1}{1.5}{-2}{2.5}
			\draw[blue] (x1) -- (x3) -- (x4) -- (x5) -- cycle; \draw[blue] (z1) -- (z3) -- (z4) -- (z5) -- cycle;
			\filldraw[blue] (x1) circle (1.5pt); \filldraw[blue] (z1) circle (1.5pt);
			\filldraw[black] (intersection of z1--z3 and x1--x3) circle (1.5pt);
			\draw[black] (intersection of z3--z4 and x4--x5) circle (2pt); &
			\draw[<->,rotate around y=-60, very thick] (0,0,0) -- (1,0,0); &
			\Tetra{1}{0}{-0.5}{-0.5}{0}{1}{1.5}{-2}{2.5}
			\draw[blue] (x1) -- (x2) -- (x4) -- (x6) -- cycle; \draw[blue] (z1) -- (z2) -- (z4) -- (z6) -- cycle;
			\filldraw[blue] (x1) circle (1.5pt); \filldraw[blue] (z1) circle (1.5pt);
			\filldraw[black] (intersection of z1--z2 and x1--x2) circle (1.5pt);
			\draw[black] (intersection of z6--z4 and x4--x2) circle (2pt); \\
		};
%		\redplane{(X1)}{(x1),(x2)}; \redplane{(X1)}{(x1),(x3)}; \redplane{(X1)}{(x2),(x3)};
%		\filldraw[blue,fill opacity=0.2] (2,-2,0) -- (2,2,0) -- (0,2,0) -- (0,2,-2) -- (0,-2,-2) -- (0,-2,0) -- cycle;
%		\redplane{(X3)}{(x2),(x3),(X4)}; \redplane{(X3)}{(x2),(x1),(z1),(z2)};
%		\redplane{(X4)}{(x3),(x1),(z1),(z3)}; \redplane{(X4)}{(X3),(z2),(z3)};
%		\filldraw[blue,fill opacity=0.2] (-2,-2,0) -- (-2,2,0) -- (0,2,0) -- (0,2,2) -- (0,-2,2) -- (0,-2,0) -- cycle;
%		\redplane{(X2)}{(z1),(z2)}; \redplane{(X2)}{(z1),(z3)}; \redplane{(X2)}{(z2),(z3)};
	\end{tikzpicture}
	\caption{Possible $X$--with--$Y$ errors.
	Blue planes are two planes of $Y$, $P_\gamma$ and $P_\eta$.
	The blue lines trace out the intersections between $X$ and the given plane.
	Blue dots represent $X$--with--$Y$ points affected by error, black dots $Y$--with--$X$ points altered by this error and black circles $Y$--with--$X$ points unaffected.}
	\label{fig:XwithY}
\end{figure}
Given that each edge of $X$ has two faces attached to it the effects of Lemma \ref{lem:XwithY} occur twice.
If neither face intersects the line $\gamma,\eta$ then after the error both do.
If one face intersects the line and the other does not the intersection moves from one face to the other.
If both faces intersect the line then after the error neither do.
Figure \ref{fig:XwithY} shows these three possible results of an $X$--with--$Y$ error.

This indicates that an $X$--with--$Y$ error can only create two, destroy two or move one $Y$--with--$X$ point(s).
In a tetrahedral intersection $Y$--with--$X$ points must come in pairs, as each line must enter then exit a convex object.
Thus, $X$--with--$Y$ errors maintain this parity.

In the absence of an intersection between this edge of $X$ and the second plane of $Y$ the sign of $q_\gamma^{ij}$, $r_\gamma^{ij}$ or $1-q_\gamma^{ij}-r_\gamma^{ij}$ is determined by the signs of $p_\eta \left ( \vec{x}_i \right )$ and $p_\eta \left ( \vec{x}_j \right )$, where $P_\eta$ is the second plane sharing the numerator of the relevant value.

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
\iffalse
% this bit should be kept, possibly moving sections, but rewritten to current standards

% these could come in handy
\newcommand{\XwithYsetup}{
	\coordinate (G11) at (2,1,0);
	\coordinate (G12) at (2,3,0);
	\coordinate (G13) at (-1,2,0);
	\coordinate (G14) at (1,2,0);
	\coordinate (G21) at (0,1,2);
	\coordinate (G22) at (0,3,2);
	\coordinate (G23) at (0,2,-1);
	\coordinate (G24) at (0,2,1);
	
	\coordinate (x1) at (-2,0.5,0);
	\coordinate (x2) at (2,0.5,0);
	\coordinate (z1) at (0,0.5,-2);
	\coordinate (z2) at (0,0.5,2);
	\coordinate (E1) at (0,0,0);
	\coordinate (E2) at (0,3,0);
	
	\coordinate (T1) at (intersection of G21--G23 and E1--E2);
	\coordinate (T2) at (intersection of G22--G23 and E1--E2);
	}
\newcommand{\axis}{
	\draw[thick,black] (x1)--(x2);
	\draw[thick,black] (z1)--(z2);
	\draw[thick,black] (E1)--(E2);
	}
\newcommand{\XwithYnodes}[3]{
	\filldraw[red] \foreach \x in {#1} {(G1\x) circle (2pt)};
	\filldraw[blue] \foreach \x in {#2} {(G2\x) circle (2pt)};
	\draw[red] (G11) \foreach \x in {#1} {--(G1\x)} -- cycle;
	\draw[blue] (G21) \foreach \x in {#2} {--(G2\x)} -- cycle;
	\filldraw[purple] \foreach \x in {#3} {(T\x) circle (2pt)};
	}
\newcommand{\XwithYfig}[4]{
	\filldraw[red,fill opacity=0.2] (G1#1) \foreach \x in {#2} {--(\x)} -- cycle;
	\filldraw[blue,fill opacity=0.2] (G2#3) \foreach \x in {#4} {--(\x)} -- cycle;
	}

This exhaustive list of the consequences of $X$--with--$Y$ errors indicates a number of instances where the volume of the polyhedron of intersection may change.
The following lemma states that the magnitude of this volume is equal to the magnitude of the error in the position of the vertices of $G_1$.

\begin{lemma}
Let $A$ be the location of a vertex of $G_1$ and let $\tilde{A}$ be the location of $A$ determined by the algorithm.
Suppose the line $A \tilde{A}$ intersects the line $E$ that bounds $F_1$ and $F_2$, and that this line has length $\delta$.
Then the change in volume caused by this error is $\order{\delta}$.
\end{lemma}

\begin{proof}
Let $B$ and $C$ be two other vertices of $G_1$ such that the lines $AB$ and $AC$ form part of the perimeter of $G_1$.
Then the area of the intersection between $G_1$ and $F_1$ is increased or decreased by at most the area of the two triangles $A \tilde{A} B$ and $A \tilde{A} C$.
Since both triangles have an edge with length $\delta$ and the diameter of $F_1$ is $\sqrt{2}$ the maximum change in area is $\sqrt{2} \delta$.
These areas form the sides of two tetrahedra.
The diameter of $Y$ is likewise $\sqrt{2}$ and so the maximum change in volume from these tetrahedra is $2\delta/3$.
\begin{figure}
\centering
\begin{tikzpicture}
\coordinate (A) at (0,-0.5);
\coordinate (B) at (-1,-3);
\coordinate (C) at (1,-3);
\coordinate (Atilde) at (0,0.5);

\draw[thick,black] (-2,0) -- (2,0) node[right] {$E$};
\draw[red] (A)--(B)--(C)-- cycle;
\draw[blue, dotted,thick] (B)--(Atilde)--(C);
\draw[decorate,decoration={brace,mirror}] (A)--(Atilde) node[midway,xshift=0.3cm] {$\delta$};
\draw[decorate,decoration={brace}] (Atilde)--(C) node[midway,xshift=0.5cm,yshift=0.1cm] {$<\sqrt{2}$};
\end{tikzpicture}
\caption{Change in area after error.}
\end{figure}

Depending on the shape of the intersection, it is possible that there is a finite number of additional tetrahedra added or removed from the volume.
Any such tetrahedron has one edge of length $\delta$.
The largest polygon that can fit inside $Y$ has area $\sqrt{3}/4$ and so the tetrahedron has a maximum volume of $\delta/4 \sqrt{3}$.
Thus the total change in volume is $\order{\delta}$.
\end{proof}
\fi
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

\subsection{$Y$--with--$X$ errors and $Y$--in--$X$ errors}

A $Y$--with--$X$ corner is an intersection between an edge of $Y$ and a face of $X$.
In our algorithm it is represented by $0 \leq t_{\gamma,\eta}^{ijk} \leq 1$.
A consistency error for this type of corner is then an error in the sign of $t_{\gamma,\eta}^{ijk}$ or $1-t_{\gamma,\eta}^{ijk}$.

To maintain consistency an error in $\sign(t_{\gamma,\eta}^{ijk})$ must affect the number of vertices of $Y$ that are found inside $X$.
That is, a $Y$--with--$X$ error must cause a $Y$--in--$X$ error.

\begin{lemma} \label{lem:YwithX}
Suppose there is an error in the sign of $t_{\gamma,\eta}^{ijk}$.
Then the vertex of $Y$ at $t_{\gamma,\eta}=0$ is determined to lie within $X$ if and only if it does not.
\end{lemma}

\begin{proof}
If the sign of $t_{\gamma,\eta}^{ijk}$ is in error then so is that of $t_{\gamma,\nu}^{ijk}$ and $t_{\nu,\eta}^{ijk}$.
If one or more of these values does not exist then there can be no error in the sign of $t_{\gamma,\eta}^{ijk}$.
For example, if $t_{\gamma,\nu}^{ijk}$ is not calculated then $\sign(r_\gamma^{ij}) = \sign(r_\gamma^{ik}) = \sign(t_{\gamma,\eta}^{ijk}).$
Some parameters and indices may need to be changed for this example to apply.

By (nb: earlier work needed here) one of the other faces of $X$ intersects the line $\gamma,\eta$ of $Y$.
This is true also for the lines $\gamma,\nu$ and $\nu,\eta$.
Denote the intersections between these lines and the other faces of $X$ as $t_{\gamma,\eta}^*$, $t_{\gamma,\nu}^*$ and $t_{\nu,\eta}^*$.

Before the error in the sign of $t_{\gamma,\eta}^{ijk}$ the three pairs of $(t^{ijk},t^*)$ shared a relation between $\sign(t^{ijk})$ and $\sign(t^*)$.
That is, either $\sign(t^{ijk})=\sign(t^*)$ for all three lines or $\sign(t^{ijk}) \neq \sign(t^*)$.
After the error this relation switched, changing from agreement in sign to disagreement or the reverse.
In the case of the former, the vertex of $Y$ at the intersection of these three lines does not lie in $X$ but is determined to do so by the algorithm.
In the latter, the vertex lies in $X$ but the algorithm does not place it there.
\end{proof}

There are four possible configurations of the three $Y$--with--$X$ points surrounding a vertex of $Y$.
This error transforms these configurations between each other, see Figure \ref{fig:YwithX}.

\begin{figure}
\centering
	\begin{tikzpicture}[rotate around y=-20]
		\matrix[row sep=1em, column sep=1em, every cell/.style={scale=0.75}]{
		\draw[black] (-2,0,0) -- (2,0,0); \draw[black] (0,-2,0) -- (0,2,0); \draw[black] (0,0,-2) -- (0,0,2);
		\filldraw[blue,opacity=0.2] (0,0,0) -- (-2,0,0) -- (-2,2,0) -- (0,2,0) -- cycle;
		\filldraw[blue,opacity=0.2] (0,0,0) -- (-2,0,0) -- (-2,0,2) -- (0,0,2) -- cycle;
		\filldraw[red,opacity=0.5] (-1,0,0) -- (0,1,0) -- (0,0,1) -- cycle;
		\filldraw[blue,opacity=0.2] (0,0,0) -- (0,0,2) -- (0,2,2) -- (0,2,0) -- cycle;
		\filldraw[blue] (-1,0,0) circle (1.5pt); \filldraw[blue] (0,1,0) circle (1.5pt); \filldraw[blue] (0,0,1) circle (1.5pt);
		\filldraw[black] (0,0,0) circle (1.5pt); &
			\draw[<->,rotate around y=20, very thick] (0,0,0) -- (1,0,0); &
		\draw[black] (-2,0,0) -- (2,0,0); \draw[black] (0,-2,0) -- (0,2,0); \draw[black] (0,0,-2) -- (0,0,2);
		\filldraw[blue,opacity=0.2] (0,0,0) -- (-2,0,0) -- (-2,2,0) -- (0,2,0) -- cycle;
		\filldraw[blue,opacity=0.2] (0,0,0) -- (-2,0,0) -- (-2,0,2) -- (0,0,2) -- cycle;
		\filldraw[red,opacity=0.5] (1,0,0) -- (0,-1,0) -- (0,0,-1) -- cycle;
		\filldraw[blue,opacity=0.2] (0,0,0) -- (0,0,2) -- (0,2,2) -- (0,2,0) -- cycle;
		\filldraw[blue] (1,0,0) circle (1.5pt); \filldraw[blue] (0,-1,0) circle (1.5pt); \filldraw[blue] (0,0,-1) circle (1.5pt);
		\filldraw[black] (0,0,0) circle (1.5pt); \\
		\filldraw[red,opacity=0.5] (-1,0,0) -- (0,1,0) -- (0,0,-1) -- cycle;
		\draw[black] (-2,0,0) -- (2,0,0); \draw[black] (0,-2,0) -- (0,2,0); \draw[black] (0,0,-2) -- (0,0,2);
		\filldraw[blue,opacity=0.2] (0,0,0) -- (-2,0,0) -- (-2,2,0) -- (0,2,0) -- cycle;
		\filldraw[blue,opacity=0.2] (0,0,0) -- (-2,0,0) -- (-2,0,2) -- (0,0,2) -- cycle;
		\filldraw[blue,opacity=0.2] (0,0,0) -- (0,0,2) -- (0,2,2) -- (0,2,0) -- cycle;
		\filldraw[blue] (-1,0,0) circle (1.5pt); \filldraw[blue] (0,1,0) circle (1.5pt); \filldraw[blue] (0,0,-1) circle (1.5pt);
		\filldraw[black] (0,0,0) circle (1.5pt); &
			\draw[<->,rotate around y=20, very thick] (0,0,0) -- (1,0,0); &
		\draw[black] (-2,0,0) -- (2,0,0); \draw[black] (0,-2,0) -- (0,2,0); \draw[black] (0,0,-2) -- (0,0,2);
		\filldraw[blue,opacity=0.2] (0,0,0) -- (-2,0,0) -- (-2,2,0) -- (0,2,0) -- cycle;
		\filldraw[blue,opacity=0.2] (0,0,0) -- (-2,0,0) -- (-2,0,2) -- (0,0,2) -- cycle;
		\filldraw[red,opacity=0.5] (1,0,0) -- (0,-1,0) -- (0,0,1) -- cycle;
		\filldraw[blue,opacity=0.2] (0,0,0) -- (0,0,2) -- (0,2,2) -- (0,2,0) -- cycle;
		\filldraw[blue] (1,0,0) circle (1.5pt); \filldraw[blue] (0,-1,0) circle (1.5pt); \filldraw[blue] (0,0,1) circle (1.5pt);
		\filldraw[black] (0,0,0) circle (1.5pt); \\
		};
	\end{tikzpicture}
	\caption{The four configurations of a face of $X$ and a vertex of $Y$.
	A $Y$--with--$X$ error transforms these configurations.
	The double-headed arrows indicate the directions of the transformations.}
	\label{fig:YwithX}
\end{figure}

\subsection{Conclusions on consistency}

Each of the errors described in this section can be represented by a change in the position of one or more of the vertices of $X$.
This change is geometric.
Therefore, the result remains an intersection between two tetrahedra.

The $X$--in--$Y$ errors are already represented as the movement of vertices of $X$.
Lemma \ref{lem:XinY} ensures the correct number of intersections with each of the planes $P_\gamma$ are calculated.

For an $X$--with--$Y$ error, the two intersections that change position lie along the same edge.
This error can then be represented by the movement of the two vertices of $X$ connected by this edge.
Lemma \ref{lem:XwithY} gives the three possible changes that result from this shift of an edge of $X$.

Finally, the three intersections altered by $Y$--with--$X$ errors fall on the same face of $X$.
The error is therefore equivalent to the shift of the three vertices of $X$ connected by this face.
Lemma \ref{lem:YwithX} provides the four changes in configuration arising from the movement of a face of $X$.

Thus, the errors are equivalent to shifts in vertices, edges and faces of $X$.
After these errors, $X$ is still a tetrahedron and the result of the algorithm an intersection between two tetrahedra.

%\section{Errors in the planes of $Y$}
%
%The remaining errors arise from the intersection the polygon $G$ and the face of $Y$ $F$.
%This part of the algorithm is taken nearly verbatim from (nb: self cite).
%The discussion therein covers 2D triangle-triangle intersections calculated with this algorithm.
%However, as shown here $G$ may not be a triangle.
%If one includes artificial vertices added by $X$--with--$Y$ errors $G$ may have up to seven vertices.
%
%Since the algorithm calculates the intersections between a given reference line and all pairs of vertices of $G$, one can treat $G$ as a triangulation of its vertices.
%Each triangle is individually intersected with $F$.
%The shared edges then mark where these intersections are to be combined.
%
%Let $G_1$ and $G_2$ be two triangles in the triangulation of $G$ such that they have an edge $E$ in common, see Figure \ref{fig:triangulation}.
%Over the course of the algorithm, the edge $E$ is intersected with $F$.
%The corresponding vertices of $G$ are found to lie inside or outside of $F$ and a commenserate number of intersections are calculated between $E$ and $F$.
%The same occurs for the remaining edges of $G_1$ and $G_2$.
%\begin{figure}
%\centering
%\begin{tikzpicture}
%\coordinate (F1) at (0,0);
%\coordinate (F2) at (0,3);
%\coordinate (F3) at (3,0);
%\coordinate (E1) at (2,3);
%\coordinate (E2) at (-1,-1);
%\coordinate (G1) at (-1,2);
%\coordinate (G2) at (2,0.5);
%\coordinate (I1) at (intersection of G1--E1 and F2--F3);
%\coordinate (I2) at (intersection of G1--E1 and F2--F1);
%\coordinate (I3) at (intersection of G2--E1 and F2--F3);
%\coordinate (I4) at (intersection of G2--E2 and F3--F1);
%\coordinate (I5) at (intersection of E1--E2 and F2--F3);
%\coordinate (I6) at (intersection of E1--E2 and F1--F2);
%
%\draw[black,thick] (F1)--(F2) node[above] {$F$} --(F3)--cycle;
%\draw[red,thick] (E2)--(G1) node[above left] {$G_1$} -- (E1);
%\draw[blue,thick] (E2)--(G2) node[below right] {$G_2$} -- (E1);
%\draw[purple,thick] (E1)--(E2) node[midway,above left] {$E$};
%\filldraw[red] \foreach \x in {1,2,3,4,5,6} {(I\x) circle (2pt)};
%\end{tikzpicture}
%\caption{Intersection between $F$ and a triangulation of $G$.
%The two triangles $G_1$ and $G_2$ that compose $G$ share an edge $E$.}
%\label{fig:triangulation}
%\end{figure}
%
%The algorithm has then calculated for $G_1$ the intersections of all its edges with $F$ and determined which vertices of $G_1$ lie inside $F$.
%Thus, the algorithm has performed the triangle-triangle intersection from (nb: self cite) on the triangles $G_1$ and $F$.
%As shown in that paper, this calculation is robust.
%The algorithm performs the same operations for the triangles $G_2$ and $F$.
%Since the two triangles share the edge $E$ and the intersections found between $E$ and $F$, taking the convex hull of the intersections does not affect the robustness of these calculations.

\section{Higher dimensions}

Having considered the intersection of triangles in (nb: self-cite) and the intersection of tetrahedra in the present paper we can now consider the general intersection of two $n$--simplices in $n$--dimensional space.
Each simplex has $n+1$ vertices.
Each pair of vertices on a given simplex defines an edge, each triple a plane, and so on.

As before we align one of the simplices to the reference simplex with vertices at the origin and $\vec{e}_\gamma$ for $\gamma=1,\dots,n$.
The vertices of $X$ are found by solving the system
\begin{equation*}
\begin{bmatrix} \vec{v}_1 & \dots & \vec{v}_n \end{bmatrix} \begin{bmatrix} \vec{x}_0 & \dots & \vec{x}_n \end{bmatrix} = \hat{U} - \vec{v}_0 \vec{1}^\top
\end{equation*}
where $\vec{v}_0$ is the vertex of $V$ mapped to the origin, $\vec{v}_i$ is the vector between $\vec{v}_0$ and the $i$--th vertex of $V$, and the columns of $\hat{U}$ are the vertices of $U$.

A vertex of $X$, $\vec{x}_i$, lies inside $Y$ only if $\vec{x}_i \cdot \vec{e}_\gamma \geq 0$ for all $\gamma$.
It is also necessary that $1 - \sum \vec{x}_i \cdot \vec{e}_\gamma \geq 0$.
For the sake of notation we denote $\vec{x} \cdot \vec{e}_0 = 1 - \sum \vec{x} \cdot \vec{e}_\gamma$.

The $(ij)$--th edge of $X$ intersects an $(n-1)$--dimensional hyperplane of $Y$, defined as $P_\gamma = \Set{\vec{x} \in \bbr^n}{\vec{x} \cdot \vec{e}_\gamma = 0}$, if $\sign(\vec{x}_i \cdot \vec{e}_\gamma) \neq \sign(\vec{x}_j \cdot \vec{e}_\gamma)$.
Proposition \ref{prop:tetra intersections} can be extended to this general dimension.

\begin{prop} \label{prop:gen}
Let $X$ be an $n$--simplex intersecting an $(n-1)$--hyperplane $P$.
At least $n$ edges of $X$ intersect $P$.
At most $\lceil{(n+1)/2}\rceil \lfloor{(n+1)/2}\rfloor$ edges of $X$ intersect $P$.
\end{prop}

\begin{proof}
Let the hyperplane $P$ be defined by $p=0$ for some linear function $p$.
An $n$--simplex has $n+1$ vertices.
Each vertex has a value of $\sign(p_i)$ equal to either 0 or 1.
There are $\lceil{(n+1)/2}\rceil$ ways to partition $n+1$ objects into two groups.
Those partitionings with the largest and smallest number of pairs are listed in Table \ref{tab:partition all}.
As it is assumed that $X$ intersects $P$ it must be that the number of edges that intersect $P$ is between $n$ and $\lceil{(n+1)/2}\rceil \lfloor{(n+1)/2}\rfloor$.
\begin{table}
    \centering
    \begin{tabular}{c|c|c}
        $m(a)$ & $m(b)$ & pairs \\ \hline
        $n+1$ & 0 & 0 \\
        $n$ & 1 & $n$ \\
        $\vdots$ & $\vdots$ & $\vdots$ \\
        $\lceil{(n+1)/2}\rceil$ & $\lfloor{(n+1)/2}\rfloor$ & $\lceil{(n+1)/2}\rceil \lfloor{(n+1)/2}\rfloor$
    \end{tabular}
    \caption{Ways to partition $n+1$ elements into two parts.}
    \label{tab:partition all}
\end{table}
\end{proof}

By Proposition \ref{prop:gen} the intersection between an $n$--simplex and an $(n-1)$--hyperplane is either an $(n-1)$--simplex embedded in an $(n-1)$--hyperplane or may be expressed as a triangulation of such simplices.
By induction each step in the algorithm computes the intersection between two objects of appropriate dimension.

Suppose we are $m$ steps through this algorithm and we are considering the intersection between the $(m-1)$--dimensional hyperplane defined by $m$ vertices of $X$ and the $(n-m)$--dimensional hyperplane defined by $m$ $(n-1)$--dimensional hyperplanes $P_\gamma$.

\begin{lemma}
Suppose the $m$--face of $X$ between the set of $m+1$ vertices $\Set{\vec{x}_i}{i \in J}$ intersects the $(n-m)$--hyperplane defined as the intersection of the $m$ hyperplanes $\Set{P_\gamma}{\gamma \in \Gamma}$.
Denote this intersection as $\vec{h}(J | \Gamma)$.
Then
\begin{equation*}
\vec{h}(J | \Gamma) \cdot \vec{e}_\eta = \frac{\begin{vmatrix} \vec{x}_{i_0} \cdot \vec{e}_\eta & \vec{x}_{i_0} \cdot \vec{e}_{\gamma_1} & \dots & \vec{x}_{i_0} \cdot \vec{e}_{\gamma_m} \\ \vdots & \vdots & & \vdots \\ \vec{x}_{i_m} \cdot \vec{e}_\eta & \vec{x}_{i_m} \cdot \vec{e}_{\gamma_1} & \dots & \vec{x}_{i_m} \cdot \vec{e}_{\gamma_m} \end{vmatrix}}{
\begin{vmatrix} 1 & \vec{x}_{i_0} \cdot \vec{e}_{\gamma_1} & \dots & \vec{x}_{i_0} \cdot \vec{e}_{\gamma_m} \\ \vdots & \vdots & & \vdots \\ 1 & \vec{x}_{i_m} \cdot \vec{e}_{\gamma_1} & \dots & \vec{x}_{i_m} \cdot \vec{e}_{\gamma_m} \end{vmatrix}}.
\end{equation*}
\end{lemma}

\begin{proof}
Without loss of generality, suppose $J =\set{0, \dots, m}$.
The $m$--face can be defined by $\Set{\vec{g}(\set{a_i})}{0 \leq a_i \leq 1}$, where
\begin{align*}
\vec{g}(\set{a_1, \dots, a_m}) = & \sum_{i=1}^m a_i \left ( \vec{x}_i - \vec{x}_{0} \right ) + \vec{x}_{0} \\
= & \sum_{i=1}^m a_i \vec{x}_i + \left ( 1 - \sum_{i=1}^m a_i \right ) \vec{x}_{m+1} .
\end{align*}

The intersection $\vec{h}(J | \Gamma) = \vec{g}(A)$ depends on $\Gamma$.
We seek the set $A = \set{a_1, \dots, a_m}$ such that
\begin{align*}
\vec{g}(A) \cdot \vec{e}_\gamma = 0 \ \forall \ \gamma \in \Gamma.
\end{align*}
We propose as a solution
\begin{align*}
a_i = & \frac{(-1)^{i}}{d} \begin{vmatrix} \vec{x}_0 \cdot \vec{e}_{\gamma_1} & \dots & \vec{x}_0 \cdot \vec{e}_{\gamma_m} \\
\vdots & & \vdots \\ \vec{x}_{i-1} \cdot \vec{e}_{\gamma_1} & \dots & \vec{x}_{i-1} \cdot \vec{e}_{\gamma_m} \\
			 	    \vec{x}_{i+1} \cdot \vec{e}_{\gamma_1} & \dots & \vec{x}_{i+1} \cdot \vec{e}_{\gamma_m} \\
\vdots & & \vdots \\ \vec{x}_{m} \cdot \vec{e}_{\gamma_1} & \dots & \vec{x}_{m} \cdot \vec{e}_{\gamma_m} \end{vmatrix}, \\
1 - \sum_{i=1}^m a_i = & \frac{1}{d} \begin{vmatrix} \vec{x}_1 \cdot \vec{e}_{\gamma_1} & \dots & \vec{x}_1 \cdot \vec{e}_{\gamma_m} \\ \vdots & & \vdots \\ \vec{x}_m \cdot \vec{e}_{\gamma_1} & \dots & \vec{x}_m \cdot \vec{e}_{\gamma_m} \end{vmatrix}
\end{align*}
for some constant $d$.
In this way the coordinates of the intersection are
\begin{equation*}
\vec{g}(A) \cdot \vec{e}_\eta = \frac{1}{d} \begin{vmatrix} \vec{x}_0 \cdot \vec{e}_\eta & \vec{x}_0 \cdot \vec{e}_{\gamma_1} & \dots & \vec{x}_0 \cdot \vec{e}_{\gamma_m} \\ \vdots & \vdots & & \vdots \\ \vec{x}_{m} \cdot \vec{e}_\eta & \vec{x}_{m} \cdot \vec{e}_{\gamma_1} & \dots & \vec{x}_{m} \cdot \vec{e}_{\gamma_m} \end{vmatrix}.
\end{equation*}
It is clear that if $\eta \in \Gamma$ then the coordinate is zero and $\vec{g}(A)$ lies on the intersection of the planes $\Set{P_\gamma}{\gamma \in \Gamma}$.

The constant $d$ is found by rearranging the formula for $1-\sum a_i$:
\begin{align*}
1 = & \frac{1}{d} \begin{vmatrix} \vec{x}_1 \cdot \vec{e}_{\gamma_1} & \dots & \vec{x}_1 \cdot \vec{e}_{\gamma_m} \\ \vdots & & \vdots \\ \vec{x}_m \cdot \vec{e}_{\gamma_1} & \dots & \vec{x}_m \cdot \vec{e}_{\gamma_m} \end{vmatrix} + \sum_{i=1}^m a_i \\
= & \sum_{i=0}^{m} \frac{(-1)^{i}}{d} \begin{vmatrix} \vec{x}_0 \cdot \vec{e}_{\gamma_1} & \dots & \vec{x}_0 \cdot \vec{e}_{\gamma_m} \\
\vdots & & \vdots \\ \vec{x}_{i-1} \cdot \vec{e}_{\gamma_1} & \dots & \vec{x}_{i-1} \cdot \vec{e}_{\gamma_m} \\
			 	    \vec{x}_{i+1} \cdot \vec{e}_{\gamma_1} & \dots & \vec{x}_{i+1} \cdot \vec{e}_{\gamma_m} \\
\vdots & & \vdots \\ \vec{x}_{m} \cdot \vec{e}_{\gamma_1} & \dots & \vec{x}_{m} \cdot \vec{e}_{\gamma_m} \end{vmatrix} \\
\implies d = & \begin{vmatrix} 1 & \vec{x}_0 \cdot \vec{e}_{\gamma_1} & \dots & \vec{x}_0 \cdot \vec{e}_{\gamma_m} \\ \vdots & \vdots & & \vdots \\ 1 & \vec{x}_{m} \cdot \vec{e}_{\gamma_1} & \dots & \vec{x}_{m} \cdot \vec{e}_{\gamma_m} \end{vmatrix}.
\end{align*}
As a small validation of this formula, if $\vec{x}_i \cdot \vec{e}_\eta = c$ then $\vec{g}(A) \cdot \vec{e}_\eta = c$.
\end{proof}

Note that the $(n-m)$--face of $Y$ on the intersection of $\Set{P_\gamma}{\gamma \in \Gamma}$ is on the positive side of the remaining planes $\Set{P_\eta}{\eta \notin \Gamma}$.
That is, $\vec{h}(J | \Gamma)$ lies on $Y$ if and only if $\vec{h}(J | \Gamma) \cdot \vec{e}_\eta \geq 0$ for all $\eta \notin \Gamma$.
Only the sign of $\vec{h}(J | \Gamma) \cdot \vec{e}_0$ is needed for this determination as the position of $\vec{h}(J | \Gamma)$ is calculated via the other scalar products.

\begin{cor} \label{cor:num}
The numerator of $\vec{h}(J | \Gamma) \cdot \vec{e}_{\eta}$ is shared with the numerators of $\vec{h}(J | \Gamma_j) \cdot \vec{e}_{j}$ for $m$ values of $j$, up to a change in sign, where $\Gamma$ and $\Gamma_j$ have cardinality $m$.
\end{cor}

\begin{proof}
For each $j \in \Gamma$ define $\Gamma_j$ as
\begin{equation*}
\Gamma_j = \set{\eta} \cup \Gamma \setminus \set{j} .
\end{equation*}
Since $\Gamma$ has $m$ elements there are $m$ such $\Gamma_j$.
For each of these the numerator of $\vec{h}(J | \Gamma_j) \cdot \vec{e}_j$ is the same up to an exchange of columns in the determinant.
\end{proof}

By this corollary, if there is a change in sign of $\vec{h}(J | \Gamma) \cdot \vec{e}_\eta$ then the entire $m$--face of $X$ defined by the indices $J$ ends up on the other side of the $(n-m)$--face of $Y$ defined by $\Gamma \cup \set{\eta}$.
If the $J$--th $m$--face of $X$ does not have $m+1$ intersections then the signs of all existing intersections can be found using the intersections of the $(m-1)$--faces of $X$ with indices that are subsets of $J$.

\subsection{Algorithm for the intersection of n-dimensional simplices}

Let $[a..b]$ represent the set of integers between $a$ and $b$.

\begin{description}
	\item[Step 1: Change of coordinates.] Find an affine transformation such that the $n+1$ vertices of $V$ are mapped to the origin and $\vec{e}_j$ for $j=1, \dots, n$.
		Use this transformation to map $U$ to the simplex $X$.
	\item[Step 2: Vertices of $X$ in $Y$.] Calculate and store the values of $p_{i,j}=\vec{e}_j \cdot \vec{x}_i$ for $i,j=0,\dots, n$.
		If $p_{i,j}$ is non-negative for all $j$ then the $i$--th vertex of $X$ lies in $Y$, and by extension the $i$--th vertex of $U$ lies in $V$.
	\item[Step 3: Edges of $X$ with planes of $Y$.] For each $j$ compare all pairs of $p_{i,j}$.
		If $\sign(p_{i,j}) \neq \sign(p_{k,j})$ then calculate $\vec{h}(\set{i,k} | \set{j}) \cdot \vec{e}_\gamma$ for all $\gamma \neq j$.
		If this value is non-negative for all $\gamma$ then the intersection $\vec{h}(\set{i,k} | \set{j})$ lies on $Y$ and forms part of the polyhedron of intersection $Z$.
	\item[Step m: Repeat $n-1$ times.] For each pair $\vec{h}(J \setminus \set{i} | \Gamma) \cdot \vec{e}_\gamma$ and $\vec{h}(J \setminus \set{k} | \Gamma) \cdot \vec{e}_\gamma$ with different sign calculate $\vec{h}(J | \Gamma \cup \set{\gamma}) \cdot \vec{e}_\eta$ for all $\eta \notin \Gamma \cup \set{\gamma}$.
		If it is positive for all such $\eta$ then the intersection $\vec{h}(J | \Gamma \cup \set{\gamma})$ lies on $Y$ and forms part of $Z$.
	\item[Step end: Vertices of $Y$ in $X$.] If $\vec{h}([0..n] \setminus \set{i} | [0..n] \setminus \set{\eta, \gamma}) \cdot \vec{e}_\gamma$ has different sign than $\vec{h}([0..n] \setminus \set{k} | [0..n] \setminus \set{\eta,\gamma}) \cdot \vec{e}_\gamma$ then the vertex of $Y$ at $\vec{e}_\eta$ lies inside $X$ and is therefore a part of $Z$.
		If $\eta = 0$ then the vertex at the origin lies inside $X$.
\end{description}

\begin{thm}
This algorithm is consistent.
\end{thm}

\begin{proof}
Outline:
\begin{itemize}
\item Prove each step of the algorithm is self-consistent;
\item Prove each step is consistent with the previous step; % i am concerned that the calculated intersections may form a non-convex object which will cause an incorrect number of intersections to be calculated - either prevent this by taking convex hulls at each step or prove it isn't a problem
\item Induction.
\end{itemize}

Each step in the algorithm, with the exception of the change of coordinates, has two components:
first, the signs of two intersections along a given direction are compared, and;
a new intersection is calculated.
A new intersection is only calculated if the signs of the two intersections along that given direction are different.
Thus, the number of intersections is consistent with the results obtained from the previous step in the algorithm.

By Corollary \ref{cor:num} the sign of the numerator of an intersection is shared amongst up to $m+1$ intersections, where $m$ is the number of planes of $Y$ on which each of the intersections sit.
These intersections represent all intersections between a given $m$--face of $X$ and the simplex $Y$.
If this $m$--face of $X$ has less than the maximum number of intersections then the signs of the numerators may be determined directly from the signs of the intersections of the $(m-1)$--faces of $X$ that compose the $m$--face.
Otherwise, the algorithm needs only calculate the sign for one of these numerators and use it for all others on this $m$--face.
In either case, this step of the algorithm is self-consistent.

Each step of the algorithm has been proven to be self-consistent and consistent with the previous step.
By induction, the algorithm as a whole is consistent for any dimension.
\end{proof}

If we apply this general algorithm to dimenion 3 and the intersection of two tetrahedra then we expect to retrieve identical results to the algorithm proposed in the previous sections.
In this particular case $\vec{x}_i = \begin{bmatrix} x_i & y_i & z_i \end{bmatrix}^\top$.

The first two steps of the algorithms already correspond to one another.
In the third step of the general algorithm $\vec{h}(\set{i,k} | \set{j}) \cdot \vec{e}_\eta$ is calculated.
Suppose $j=1$ and $\eta=2$, then
\begin{equation*}
\vec{h}(\set{i,k}|\set{1}) \cdot \vec{e}_2 = \frac{\begin{vmatrix} y_i & x_i \\ y_k & x_k \end{vmatrix}}{\begin{vmatrix} 1 & x_i \\ 1 & x_k \end{vmatrix}}.
\end{equation*}
This is identical to $q^{ik}_x$ from the tetrahedral algorithm.
It is straightforward to work out that the other combinations of $j$ and $\eta$ will give the equations for $q^{ik}_\gamma$, $r^{ik}_\gamma$ and $1-q^{ik}_\gamma-r^{ik}_\gamma$.
Likewise, one can show the calculations in step m, repeated once in this case, are identical to those of step 2bi of the tetrahedral algorithm.
Since these calculations are the same, the comparison of the signs of the intersections will return the same results.
Thus, both algorithms will agree as to which vertices of $Y$ lie inside $X$.

\end{document}